local bs = AceLibrary("Babble-Spell-2.2")
local AceAddon = AceLibrary("AceAddon-2.0")
local Tablet = AceLibrary("Tablet-2.0")

local L = AceLibrary("AceLocale-2.2"):new("Cartographer_Treasure")
L:RegisterTranslations("enUS", function() return {
	["Filter"] = true,
	["Filter out treasure"] = true,	
	["Select all"] = true,
	["Select none"] = true,
	["Treasure"] = true,
	-- Icons
	["Box"] = true,
	["Chest"] = true,
	["Clam"] = true,
	["Barrel"] = true,
	["Shellfish"] = true,
	["Footlocker"] = true,
	["Blood"] = true,
	["Soil"] = true,
	["Sprout"] = true,
	["Crystal"] = true,
	["Berries"] = true,
	["Tuber"] = true,
	["Nightdragon"] = true,
	["Songflower"] = true,
	
	-- Descriptive/Menu names
	["Blood of Heroes"] = true,
	["Un'Goro Dirt Pile"] = true,
	["Bloodpetal Sprout"] = true,
	["Power Crystal"] = true,
	["Food Crate"] = true,
	["Drink Barrel"] = true,
	["Shellfish Trap"] = true,
	["Giant Clam"] = true,
	["Un'Goro Power Crystal"] = true,
	["Night Dragon's Breath"] = true,
	["Nightdragon"] = true,
	["Whipper Root Tuber"] = true,
	["Whipper Root"] = true,
	["Windblossom Berries"] = true,
	["Songflower"] = true,
	-- regex needs
	["Crate"] = true,
	["Cask"] = true,
	["Dirt Pile"] = true,
	
} end)

L:RegisterTranslations("deDE", function() return {
	
} end)

L:RegisterTranslations("frFR", function() return {
} end)

L:RegisterTranslations("esES", function() return {
} end)

L:RegisterTranslations("koKR", function() return {
	["Filter"] = "필터링",
} end)

L:RegisterTranslations("zhTW", function() return {
	["Filter"] = "篩檢",
} end)

L:RegisterTranslations("zhCN", function() return {
--	["Filter"] = true,	
} end)

local Cartographer_Treasure = Cartographer:NewModule("Treasure", "AceConsole-2.0", "AceEvent-2.0")

-- Filter configuration
Cartographer_Treasure.filter = {
	["Barrel"] = L["Drink Barrel"],
	["Blood"] = L["Blood of Heroes"],
	["Box"] = L["Food Crate"],
	["Chest"] = L["Chest"],
	["Clam"] = L["Giant Clam"],
	["Crystal"] = L["Un'Goro Power Crystal"],
	["Shellfish"] = L["Shellfish Trap"],
	["Footlocker"] = L["Footlocker"],
	["Soil"] = L["Un'Goro Dirt Pile"],
	["Sprout"] = L["Bloodpetal Sprout"]
}
Cartographer_Treasure.felwood_filter = {
	["Whipper Root"] = L["Whipper Root Tuber"],
	["Songflower"] = L["Songflower"],
	["Nightdragon"] = L["Night Dragon's Breath"],
	["Windblossom Berries"] = L["Windblossom Berries"],	
}
Cartographer_Treasure.icon = {
	["Box"] = {
		text = L["Box"],
		path = "Interface\\AddOns\\Cartographer_Treasure\\Artwork\\Crate",
		width = 14,
		height = 14,
	},
--	["Windblossom Berries"] = {
--		text = L["Windblossom Berries"],
--		path = "Interface\\AddOns\\Cartographer_Treasure\\Artwork\\Berries",
--		width = 14,
--		height = 14,
--	},
	["Barrel"] = {
		text = L["Barrel"],
		path = "Interface\\AddOns\\Cartographer_Treasure\\Artwork\\Barrel",
		width = 14,
		height = 14
	},
	["Blood"] = {
		text = L["Blood"],
		path = "Interface\\AddOns\\Cartographer_Treasure\\Artwork\\HeroBlood",
		width = 14,
		height = 14
	},
	["Chest"] = {
		text = L["Chest"],
		path = "Interface\\AddOns\\Cartographer_Treasure\\Artwork\\Chest",
		width = 14,
		height = 14
	},
	["Clam"] = {
		text = L["Clam"],
		path = "Interface\\AddOns\\Cartographer_Treasure\\Artwork\\ClamShell",
		width = 14,
		height = 14
	},
	["Crystal"] = {
		text = L["Crystal"],
		path = "Interface\\AddOns\\Cartographer_Treasure\\Artwork\\Crystal",
		width = 14,
		height = 14
	},
--	["Nightdragon"] = {
--		text = L["Nightdragon"],
--		path = "Interface\\AddOns\\Cartographer_Treasure\\Artwork\\Sprout",
--		width = 14,
--		height = 14
--	},
	["Shellfish"] = {
		text = L["Shellfish"],
		path = "Interface\\AddOns\\Cartographer_Treasure\\Artwork\\Lobster",
		width = 14,
		height = 14
	},
	["Footlocker"] = {
		text = L["Footlocker"],
		path = "Interface\\AddOns\\Cartographer_Treasure\\Artwork\\Footlocker",
		width = 14,
		height = 14
	},
	["Soil"] = {
		text = L["Soil"],
		path = "Interface\\AddOns\\Cartographer_Treasure\\Artwork\\Soil",
		width = 14,
		height = 14
	},
--	["Whipper Root"] = {
--		text = L["Whipper Root"],
--		path = "Interface\\AddOns\\Cartographer_Treasure\\Artwork\\Tuber",
--		width = 14,
--		height = 14
--	},
--	["Songflower"] = {
--		text = L["Songflower"],
--		path = "Interface\\AddOns\\Cartographer_Treasure\\Artwork\\songflower",
--		width = 14,
--		height = 14
--	},
	["Sprout"] = {
		text = L["Sprout"],
		path = "Interface\\AddOns\\Cartographer_Treasure\\Artwork\\Sprout",
		width = 14,
		height = 14
	},
}
local regex_filter = {
	-- food boxes
	[L["Box"]] = "Box",
	[L["Crate"]] = "Box",
	-- chest goodies
	[L["Chest"]] = "Chest",
	-- underwater clam
	[L["Clam"]] = "Clam",
	-- drink tanks
	[L["Barrel"]] = "Barrel",
	[L["Cask"]] = "Barrel",
	-- Shellfish trap
	[L["Shellfish"]] = "Shellfish",
	-- rogue practice footlockers
	[L["Footlocker"]] = "Footlocker",
	-- EPL/WPL blood
	[L["Blood of Heroes"]] = "Blood",
	-- Ungoro
	[L["Un'Goro Dirt Pile"]] = "Soil",
	[L["Dirt Pile"]] = "Soil",
	[L["Bloodpetal Sprout"]] = "Sprout",
	[L["Power Crystal"]] = "Crystal",
	-- Felwood
	[L["Nightdragon"]] = "Nightdragon",
	[L["Songflower"]] = "Songflower",
	[L["Windblossom Berries"]] = "Windblossom Berries",
	[L["Whipper Root"]] = "Whipper Root",
}
function Cartographer_Treasure:OnInitialize()
	self.db = Cartographer:AcquireDBNamespace("Treasure")
	Cartographer:RegisterDefaults("Treasure", "profile", {
		filter = {
			['*'] = true,
		}
	})
	if not self.db.server.cache then
		self.db.server.cache = {}
	end
	
	local aceopts = {}
	aceopts.toggle = {
		name = AceLibrary("AceLocale-2.2"):new("Cartographer")["Enabled"],
		desc = AceLibrary("AceLocale-2.2"):new("Cartographer")["Suspend/resume this module."],
		type  = 'toggle',
		order = -1,
		get   = function() return Cartographer:IsModuleActive(self) end,
		set   = function() Cartographer:ToggleModuleActive(self) end,
	}

	aceopts.filter = {
		name = L["Filter"],
		desc = L["Filter out treasure"],
		type = 'group',
		args = {
			all = {
				name = L["Select all"],
				desc = L["Select all"],
				type = 'execute',
				func = function()
					for k in pairs(self.icon) do
						self:ToggleShowingTreasure(k, true)
					end
				end,
				order = 1,
			},
			none = {
				name = L["Select none"],
				desc = L["Select none"],
				type = 'execute',
				func = function()
					for k in pairs(self.icon) do
						self:ToggleShowingTreasure(k, false)
					end
				end,
				order = 2,
			},
			blank = {
				type = 'header',
				order = 3,
			}
		}
	}
	Cartographer.options.args.Treasure = {
		name = L["Treasure"],
		desc = self.notes,
		type = 'group',
		args = aceopts,
		handler = self,
	}

	for k,v in pairs(self.filter) do
		local k = k
		aceopts.filter.args[k] = {
			name = v,
			desc = v,
			type = 'toggle',
			get = function()
				return self:IsShowingTreasure(k)
			end,
			set = function(value)
				return self:ToggleShowingTreasure(k, value)
			end,
		}
	end
	-- Felwood farmer support
	local _, _, _, fenabled, floadable, freason, _ = GetAddOnInfo("FelwoodFarmer")
	if fenabled then
		for k,v in pairs(self.felwood_filter) do
			local k = k
			aceopts.filter.args[k] = {
				name = v,
				desc = v,
				type = 'toggle',
				get = function()
					return self:IsShowingTreasure(k)
				end,
				set = function(value)
					return self:ToggleShowingTreasure(k, value)
					end,
			}
		end	
	end
	
	if not Cartographer_TreasureDB then
		Cartographer_TreasureDB = {}
	else
		-- fix up broken notes
		for name, zone in pairs(Cartographer_TreasureDB) do
			if type(zone) == "table" then
				for id, data in pairs(zone) do
					if type(data) == "string" then
						local oname = data
						data = {}
						data.icon = self:getIcon(oname)
						data.title = oname
						zone[id] = data
					else
						if not data.icon then
							data.icon = self:getIcon(data.title)
							zone[id] = data
						end
					end
				end
			end
		end
	end
end

-- Enable function
function Cartographer_Treasure:OnEnable()
	if Cartographer_Notes then
		self:RegisterEvent("UI_ERROR_MESSAGE")
		self:RegisterEvent("UNIT_SPELLCAST_START")
		self:RegisterEvent("CHAT_MSG_SPELL_SELF_BUFF")
		if not self.iconsregistered then
			for k,v in pairs(self.icon) do
				Cartographer_Notes:RegisterIcon(k, v)
			end
			self.iconsregistered = true
		end
		Cartographer_Notes:RegisterNotesDatabase('Treasure', Cartographer_TreasureDB, self)
	else
		Cartographer:ToggleTreasureActive(self, false)
	end
end

-- Disbale function
function Cartographer_Treasure:OnDisable()
	self:UnregisterAllEvents()
	if Cartographer_Notes then
		Cartographer_Notes:UnregisterNotesDatabase('Treasure')
	end
end

-- Set the note
function Cartographer_Treasure:SetNote(what,details)
	local x, y = GetPlayerMapPosition("player")
	if x == 0 and y == 0 then return end
	local zone = GetRealZoneText()
	for zone, x_p, y_p, icon, creator, data in Cartographer_Notes:IterateNearbyNotes(zone, x, y, 8, "Treasure", nil, true) do
		if icon == what then
			Cartographer_Notes:DeleteNote(zone, x_p, y_p)
		end
	end
	Cartographer_Notes:SetNote(zone, x, y, what, "Treasure",'title',details)
end

function Cartographer_Treasure:OnNoteTooltipRequest(zone, id, treasure_data, minimap)
	Tablet:SetTitle(treasure_data.title)
	Tablet:SetTitleColor(0, 0.8, 0)	
	if Cartographer_Notes:IsShowingCreator() and not minimap then
		Tablet:AddCategory(
			'columns', 2,
			'hideBlankLine', true
		):AddLine(
			'text', AceLibrary("AceLocale-2.2"):new("Cartographer-Notes")["Created by"],
			'text2', L["Treasure"]
		)
	end
end

function Cartographer_Treasure:getIcon(item)
	if item and item:len() > 0 then	
		local item = item:gsub("^(.-) %(%d+%)$", "%1")
		if self.db.server.cache[item] then
			return self.db.server.cache[item]
		end
		for k,v in pairs(regex_filter) do
			if item:match(k) then
				self.db.server.cache[k] = v
				return v
			end
		end
		return nil
	else
		return nil
	end
end

-- regex match
function Cartographer_Treasure:RegisterTreasure(what)
	local icon = self:getIcon(what)
	if icon then
		if what:match(L["Power Crystal"]) then
			what = L["Un'Goro Power Crystal"]
		end
		self:SetNote(icon,what)
	end	
end

-- i used this from cart mining seemes over complicated, but maybe due to localization issues
local perform_string = '^' .. (SIMPLEPERFORMSELFOTHER:format(bs["Opening"], "%s"):gsub("([%(%)%.%*%+%-%[%]%?%^%$%%])", "%%%1"):gsub("%%%%s", "(.+)")) .. '$'
-- this should be fired when you open something see 2.02 release ntoes
function Cartographer_Treasure:CHAT_MSG_SPELL_SELF_BUFF(msg)
	local what = msg:match(perform_string)
	if what then
		self:RegisterTreasure(what)
	end
end

-- opening now seems to just do a blank "Opening cast spell"
function Cartographer_Treasure:UNIT_SPELLCAST_START(who)
	-- only care about our own cast events
	if ( who ~= "player" ) then 
		return 
	end
	local spell, _, text, _, _, _ = UnitCastingInfo("player")
	-- make sure we are performing Opening; the spell and text should both be "Opening"
	-- Lockpicking for footlockers never calls 
	if (text == bs["Opening"] and spell == bs["Opening"]) or (text == bs["Pick Lock"] and spell == bs["Pick Lock"]) then
		local what = GameTooltipTextLeft1:GetText();
		if what then
			self:RegisterTreasure(what)
		end
	end
end

-- Error: you're in comabt or mounted
function Cartographer_Treasure:UI_ERROR_MESSAGE(msg)
	-- see if we are trying to open/activate something while mounted
	if msg:find(SPELL_FAILED_NOT_MOUNTED) or msg:find(ERR_NOT_IN_COMBAT) then
		local what = GameTooltipTextLeft1:GetText()
		if what then
			self:RegisterTreasure(what)
		end
	end
end

function Cartographer_Treasure:IsNoteHidden(zone, id, treasure)
	return not self.db.profile.filter[treasure.icon]
end

function Cartographer_Treasure:IsShowingTreasure(treasure)
	return self.db.profile.filter[treasure]
end

function Cartographer_Treasure:ToggleShowingTreasure(treasure, value)
	if value == nil then
		value = not self.db.profile.filter[treasure]
	end
	self.db.profile.filter[treasure] = value
	Cartographer_Notes:RefreshMap()
end

